#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
//#include <sys/timeb.h>
//#include <time.h>

#include <windows.h>

#include "types.h"
#include "md5.h"

typedef int (funcPtr)( ord32 totalLen, ord32 prefixLen, ord32 searchLen, ord32 listLen,
		 ord32 *hash, ord32 *startPoint, ord8 *prefix, ord8 *list);

/* External Functions */
funcPtr searchcore01;
funcPtr searchcore02;
funcPtr searchcore03;
funcPtr searchcore04;
funcPtr searchcore05;
funcPtr searchcore06;
funcPtr searchcore07;
funcPtr searchcore08;

void testit(void);

/* Internal Functions */
void undo64to56(ord32 *out, ord32 *in, ord8 *buffer); 
ord8  getVal(char arg);
void getcodefromarg(ord8 *code,char *arg);
int  getIndex(char c, char *list, int listLen);

#define defaultKeys    "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"

ord8
getVal(char arg)
{
	switch(arg) {
	case '0': return 0;
	case '1': return 1;
	case '2': return 2;
	case '3': return 3;
	case '4': return 4;
	case '5': return 5;
	case '6': return 6;
	case '7': return 7;
	case '8': return 8;
	case '9': return 9;
	case 'a':	
	case 'A': return 10;
	case 'b':
	case 'B': return 11;
	case 'c':
	case 'C': return 12;
	case 'd':
	case 'D': return 13;
	case 'e':
	case 'E': return 14;
	case 'f':
	case 'F': return 15;
	}
	return 0;
}

void
getcodefromarg(ord8 *code,char *arg)
{
        int i;
		ord32   *state[4];
		ord8 tmp;

        if(strlen(arg) != 32)
        {
                printf(" MD5 Hash has to be 32 characters long\n");
                exit(1);
        }
    
        for(i=0; i<32; i++) {
                tmp = getVal(arg[i]);
                if( i%2 ) {
                        code[i/2] += tmp;
                } else {
                        code[i/2] += tmp << 4;
                }
        }
 
        // normalize code value

        state[0] = (ord32*)&code[0];
        state[1] = (ord32*)&code[4];
        state[2] = (ord32*)&code[8]; 
        state[3] = (ord32*)&code[12];

        *state[0] -= 0x67452301;
        *state[1] -= 0xefcdab89;  
        *state[2] -= 0x98badcfe;
        *state[3] -= 0x10325476;
 
}




int
getIndex(char c, char *list, int listLen)
{
      int i;
      
      for(i=0; i < listLen; i++){
	    if(c == list[i]) {
		  return i+1;
	    }
      }
      return 0;
}

int 
main(int argc, char** argv)
{
	int keyMax;
	int keyLen;
	int i;
      
    ord32	startNum[7+1];      
    ord32	checkCode[4];
    ord8	checklist[92+2];
      
    memset(checkCode,0,sizeof(ord32)*4);

    //getcodefromarg((ord8*)checkCode,"f71dbe52628a3f83a77ab494817525c6");	
    getcodefromarg((ord8*)checkCode,"d5cdb87b32cf33a3aa68b64cc16de3a3");	


    keyMax = strlen(defaultKeys);
	memcpy(checklist, defaultKeys, keyMax);
/*	load 0x80 and 0x00 into checklist
 */
	checklist[keyMax] = 0x80;
	checklist[keyMax+1] = 0x00;
      
    keyLen=4;

	for( i=0; i<keyLen; i++ )
	{
		startNum[i] = 0;
	}
	
	startNum[i] = keyMax;

	for( i=keyLen+1; i<8; i++)
	{
		startNum[i] = keyMax+1;
	}
	


	//testit();
	//exit(0);

	searchcore01( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
	searchcore02( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
	searchcore03( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);

	searchcore01( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
	searchcore02( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
	searchcore03( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);

	//searchcore04( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
    //searchcore05( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
    //searchcore06( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
    //searchcore07( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
    //searchcore08( keyLen, 0, keyLen, keyMax, (ord32*)&checkCode, startNum , "", checklist);
    



		  
	return 0;

}




void
undo64to56(ord32 *out, ord32 *in, ord8 *buffer) 
{
      ord32 a, b, c, d;
      ord32 *x = (ord32*)buffer;
      // on big endian x needs to be decoded

      a = in[0];
      b = in[1];
      c = in[2];
      d = in[3];

      RII (b, c, d, a, x[ 9], S44, 0xeb86d391); /* 64 */
      RII (c, d, a, b, x[ 2], S43, 0x2ad7d2bb); /* 63 */
      RII (d, a, b, c, x[11], S42, 0xbd3af235); /* 62 */
      RII (a, b, c, d, x[ 4], S41, 0xf7537e82); /* 61 */
      RII (b, c, d, a, x[13], S44, 0x4e0811a1); /* 60 */
      RII (c, d, a, b, x[ 6], S43, 0xa3014314); /* 59 */
      RII0 (d, a, b, c,       S42, 0xfe2ce6e0); /* 58 */
      RII (a, b, c, d, x[ 8], S41, 0x6fa87e4f); /* 57 */
      RII0 (b, c, d, a,       S44, 0x85845dd1); /* 56 */

      out[0]=a;
      out[1]=b;
      out[2]=c;
      out[3]=d;
}

void
testit(void)
{
	ord32	a;
	ord32 i,j,k,l;
	ord32 e,f, same,tot;


	ord32 *x;
	ord8 b[4];
	ord8 list[] = {"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"};
		
	same = 0;
	tot = 0;
	
#define bit(x,b) ((x&(0x00000001<<b)>>b)

	e = 0xd76aa477;
	ROTATE_LEFT (e, S11);
	e += 0xefcdab89;

	x = (ord32 *)b;

	for ( i=0; i<62;i++)
	{
		b[3] = list[i];	
		for ( j=0; j<62; j++ )
		{
			b[2] = list[j];
			for ( k=0; k<62;k++)
			{
				b[1] = list[k];	
				for ( l=0; l<62; l++ )
				{
					b[0] = list[l];
					
					a = 0xd76aa477 + *x;
					ROTATE_LEFT (a, S11); 
					a += 0xefcdab89;
					
					
					e = 0xd76aa477 + *x; 
					f= *x;
	
					//s = bit(f,24) ^ bit(e,24);
					//c = bit(f,24) ^ bit(e,24);

						
					ROTATE_LEFT (f,S11);
					f+=e;

					tot++;
					if(f == a )
					{
						same++;
					}
				}
			}
		}
	}

	printf ("total: %u same: %u \n",tot,same);
}

